# [Blog in a Matrix](https://bloginamatrix.xyz)

New server side rendered blog site written in Nim.

Articles/blogs written in markdown using [Joplin](https://github.com/laurent22/joplin/ "The best notes app/markdown editor ever made.") then exported as `HTML` to the `/src/public` directory. Joplin has support for [the extended markdown syntax](https://github.com/laurent22/joplin/blob/dev/readme/markdown.md), [KaTeX](https://khan.github.io/KaTeX/), and [Mermaid.js](https://mermaidjs.github.io/) out of the box. The syntax can be farther extended with [plugins](https://github.com/joplin/plugins/) (e.g. [music sheet notation](https://github.com/joplin/plugin-abc-sheet-music)).

MTH tech stack is used, pronounced _Meth_ or _Math_:

- [Markdown](https://daringfireball.net/projects/markdown/)
- [Tailwindcss](https://tailwindcss.com/)
- [HappyX](https://hapticx.github.io/happyx/)

## Development

Install Nim dependencies:

```sh
nimble install happyx
```

Build website:

```sh
nim c "src/main.nim"
```

Run HTTP server:

```sh
./main
```

Build debug site and run server using a single command:

```sh
nim c -d:debug -r "src/main.nim"
```
